Index: trunk/NEMO/OPA_SRC/SBC/sbcflx.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 888)
+++ trunk/NEMO/OPA_SRC/SBC/sbcflx.F90	(revision 888)
@@ -0,0 +1,199 @@
+MODULE sbcflx
+   !!======================================================================
+   !!                       ***  MODULE  sbcflx  ***
+   !! Ocean forcing:  momentum, heat and freshwater flux formulation
+   !!=====================================================================
+   !! History :  9.0   !  06-06  (G. Madec)  Original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   namflx   : flux formulation namlist
+   !!   sbc_flx  : flux formulation as ocean surface boundary condition
+   !!              (forced mode, fluxes read in NetCDF files)
+   !!----------------------------------------------------------------------
+   !! question diverses
+   !!  *   ajouter un test sur la division entier de freqh et rdttra ???
+   !!  **  ajoute dans namelist: 1 year forcing files
+   !!                         or forcing file starts at the begining of the run
+   !!  *** we assume that the forcing file start and end with the previous
+   !!      year last record and the next year first record (useful for
+   !!      time interpolation, required even if no time interp???)
+   !!  *   ajouter un test sur la division de la frequence en pas de temps
+   !!  ==> daymod ajout de nsec_year = number of second since the begining of the year
+   !!      assumed to be 0 at 0h january the 1st (i.e. 24h december the 31)
+   !!
+   !!  *** regrouper dtatem et dtasal
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE phycst          ! physical constants
+   USE daymod          ! calendar
+   USE ocfzpt          ! ocean freezing point
+   USE fldread         ! read input fields
+   USE iom             ! IOM library
+   USE in_out_manager  ! I/O manager
+   USE lib_mpp         ! distribued memory computing library
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC sbc_flx       ! routine called by step.F90
+
+   INTEGER , PARAMETER ::   jpfld   = 5   ! maximum number of files to read 
+   INTEGER , PARAMETER ::   jp_utau = 1   ! index of wind stress (i-component) file
+   INTEGER , PARAMETER ::   jp_vtau = 2   ! index of wind stress (j-component) file
+   INTEGER , PARAMETER ::   jp_qtot = 3   ! index of total (non solar+solar) heat file
+   INTEGER , PARAMETER ::   jp_qsr  = 4   ! index of solar heat file
+   INTEGER , PARAMETER ::   jp_emp  = 5   ! index of evaporation-precipation file
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf    ! structure of input fields (file informations, fields read)
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE sbc_flx( kt )
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE sbc_flx  ***
+      !!                   
+      !! ** Purpose :   provide at each time step the surface ocean fluxes
+      !!                (momentum, heat, freshwater and runoff) 
+      !!
+      !! ** Method  : - READ each fluxes in NetCDF files:
+      !!                   i-component of the stress              utau  (N/m2)
+      !!                   j-component of the stress              vtau  (N/m2)
+      !!                   net downward heat flux                 qtot  (watt/m2)
+      !!                   net downward radiative flux            qsr   (watt/m2)
+      !!                   net upward freshwater (evapo - precip) emp   (kg/m2/s)
+      !!                Assumptions made:
+      !!                 - each file content an entire year (read record, not the time axis)
+      !!                 - first and last record are part of the previous and next year
+      !!                   (useful for time interpolation)
+      !!                 - the number of records is 2 + 365*24 / freqh(jf)
+      !!                   or 366 in leap year case
+      !!
+      !!      CAUTION :  - never mask the surface stress fields
+      !!                 - the stress is assumed to be in the mesh referential
+      !!                   i.e. the (i,j) referential
+      !!
+      !! ** Action  :   update at each time-step
+      !!              - utau  & vtau    : stress components in (i,j) referential
+      !!              - qns             : non solar heat flux
+      !!              - qsr             : solar heat flux
+      !!              - emp             : evap - precip (volume flux)
+      !!              - emps            : evap - precip (concentration/dillution)
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time step
+      !!
+      INTEGER  ::   ji, jj, jf   ! dummy indices
+      INTEGER  ::   ierror       ! return error code
+      REAL(wp) ::   zfact        ! temporary scalar
+      !!
+      CHARACTER(len=100) ::  cn_dir                               ! Root directory for location of flx files
+      TYPE(FLD_N), DIMENSION(jpfld) ::   slf_i                    ! array of namelist information structures
+      TYPE(FLD_N) ::   sn_utau, sn_vtau, sn_qtot, sn_qsr, sn_emp  ! informations about the fields to be read
+      NAMELIST/namsbc_flx/ cn_dir, sn_utau, sn_vtau, sn_qtot, sn_qsr, sn_emp
+      !!---------------------------------------------------------------------
+   INTEGER , PARAMETER ::   jp_utau = 1   ! index of wind stress (i-component) file
+   INTEGER , PARAMETER ::   jp_vtau = 2   ! index of wind stress (j-component) file
+   INTEGER , PARAMETER ::   jp_qtot = 3   ! index of total (non solar+solar) heat file
+   INTEGER , PARAMETER ::   jp_qsr  = 4   ! index of solar heat file
+   INTEGER , PARAMETER ::   jp_emp  = 5   ! index of evaporation-precipation file
+
+
+      !                                         ! ====================== !
+      IF( kt == nit000 ) THEN                   !  First call kt=nit000  !
+         !                                      ! ====================== !
+         ! set file information
+         cn_dir = './'        ! directory in which the model is executed
+         ! ... default values (NB: frequency positive => hours, negative => months)
+         !            !   file    ! frequency !  variable  ! time intep !  clim  ! starting !
+         !            !   name    !  (hours)  !   name     !   (T/F)    !  (0/1) !  record  !
+         sn_utau = FLD_N( 'utau.nc' ,    24.    ,  'utau'    ,  .FALSE.   ,    0   ,     0    )
+         sn_vtau = FLD_N( 'vtau.nc' ,    24.    ,  'vtau'    ,  .FALSE.   ,    0   ,     0    )
+         sn_qtot = FLD_N( 'qtot.nc' ,    24.    ,  'qtot'    ,  .FALSE.   ,    0   ,     0    )
+         sn_qsr  = FLD_N( 'qsr.nc'  ,    24.    ,  'qsr'     ,  .FALSE.   ,    0   ,     0    )
+         sn_emp  = FLD_N( 'emp.nc'  ,    24.    ,  'emp'     ,  .FALSE.   ,    0   ,     0    )
+
+         REWIND ( numnam )               ! ... read in namlist namflx
+         READ   ( numnam, namsbc_flx ) 
+
+         ! store namelist information in an array
+         slf_i(jp_utau) = sn_utau   ;   slf_i(jp_vtau) = sn_vtau
+         slf_i(jp_qtot) = sn_qtot   ;   slf_i(jp_qsr ) = sn_qsr 
+         slf_i(jp_emp ) = sn_emp
+
+         ! set sf structure
+         ALLOCATE( sf(jpfld), STAT=ierror )
+         IF( ierror > 0 ) THEN
+            CALL ctl_stop( 'sbc_flx: unable to allocate sf structure' )   ;   RETURN
+         ENDIF
+
+         DO jf = 1, jpfld
+            WRITE(sf(jf)%clrootname,'(a,a)' )   TRIM( cn_dir ), TRIM( slf_i(jf)%clname )
+            sf(jf)%freqh   = slf_i(jf)%freqh
+            sf(jf)%clvar   = slf_i(jf)%clvar
+            sf(jf)%ln_tint = slf_i(jf)%ln_tint
+            sf(jf)%nclim   = slf_i(jf)%nclim
+            sf(jf)%nstrec  = slf_i(jf)%nstrec
+         END DO
+
+         IF(lwp) THEN      ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) 'sbc_flx : flux formulation for ocean surface boundary condition'
+            WRITE(numout,*) '~~~~~~~ '
+            WRITE(numout,*) '          namsbc_flx Namelist'
+            WRITE(numout,*) '          list of files and frequency (>0: in hours ; <0 in months)'
+            DO jf = 1, jpfld
+                WRITE(numout,*) '               root filename: '  , trim( sf(jf)%clrootname ),   &
+                   &                          ' variable name: '  , trim( sf(jf)%clvar      )
+                WRITE(numout,*) '               frequency: '      ,       sf(jf)%freqh       ,   &
+                   &                          ' time interp: '    ,       sf(jf)%ln_tint     ,   &
+                   &                          ' climatology: '    ,       sf(jf)%nclim       ,   &
+                   &                          ' starting record: ',       sf(jf)%nstrec
+            END DO
+         ENDIF
+         !
+      ENDIF
+
+      CALL fld_read( kt, nn_fsbc, sf )           ! Read input fields and provides the
+      !                                          ! input fields at the current time-step
+
+      ! set the ocean fluxes from read fields
+!CDIR COLLAPSE
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            utau(ji,jj) = sf(jp_utau)%fnow(ji,jj)
+            vtau(ji,jj) = sf(jp_vtau)%fnow(ji,jj)
+            qns (ji,jj) = sf(jp_qtot)%fnow(ji,jj) - sf(jp_qsr)%fnow(ji,jj)
+            qsr (ji,jj) = sf(jp_qsr )%fnow(ji,jj)
+            emp (ji,jj) = sf(jp_emp )%fnow(ji,jj)
+         END DO
+      END DO
+
+      ! control print (if less than 100 time-step asked)
+      IF( nitend-nit000 <= 100 .AND. lwp ) THEN
+         WRITE(numout,*) 
+         WRITE(numout,*) '        read daily momentum, heat and freshwater fluxes OK'
+         DO jf = 1, jpfld
+            IF( jf == jp_utau .OR. jf == jp_vtau )   zfact =     1.
+            IF( jf == jp_qtot .OR. jf == jp_qsr  )   zfact =     0.1
+            IF( jf == jp_emp                     )   zfact = 86400.
+            WRITE(numout,*) 
+            WRITE(numout,*) ' day: ', ndastp , TRIM(sf(jf)%clvar), ' * ', zfact
+            CALL prihre( sf(jf)%fnow, jpi, jpj, 1, jpi, 20, 1, jpj, 10, 1., numout )
+         END DO
+         CALL FLUSH(numout)
+      ENDIF
+      !
+   END SUBROUTINE sbc_flx
+
+   !!======================================================================
+END MODULE sbcflx
Index: trunk/NEMO/OPA_SRC/SBC/sbcfwb.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 888)
+++ trunk/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 888)
@@ -0,0 +1,150 @@
+MODULE sbcfwb
+   !!======================================================================
+   !!                       ***  MODULE  sbcfwb  ***
+   !! Ocean fluxes   : domain averaged freshwater budget
+   !!======================================================================
+   !! History :  8.2  !  01-02  (E. Durand)  Original code
+   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!            9.0  !  06-08  (G. Madec)  Surface module
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   sbc_fwb      : freshwater budget for global ocean configurations
+   !!                  in free surface and forced mode
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE sbc_oce         ! surface ocean boundary condition
+   USE cpl_oce         ! coupled atmosphere/ocean
+   USE phycst          ! physical constants
+   USE sbcrnf          ! ocean runoffs
+   USE daymod          ! calendar
+   USE in_out_manager  ! I/O manager
+   USE lib_mpp         ! distribued memory computing library
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   sbc_fwb      ! routine called by step
+
+   REAL(wp) ::   a_fwb_b            ! annual domain averaged freshwater budget
+   REAL(wp) ::   a_fwb              ! for 2 year before (_b) and before year.
+   REAL(wp) ::   empold             ! empold to be suppressed
+   REAL(wp) ::   area               ! global mean ocean surface (interior domain)
+
+   REAL(wp), DIMENSION(jpi,jpj) ::   e1e2_i    ! area of the interior domain (e1t*e2t*tmask_i)
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!  OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE sbc_fwb( kt, kn_fwb, kn_fsbc )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE sbc_fwb  ***
+      !!
+      !! ** Purpose :   Control the mean sea surface drift
+      !!
+      !! ** Method  :   several ways  depending on kn_fwb
+      !!                =0 no control 
+      !!                =1 annual global mean corrected from previous year
+      !!                =2 global mean of emp set to zero at each nn_fsbc time step
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt       ! ocean time-step index
+      INTEGER, INTENT( in ) ::   kn_fsbc  ! 
+      INTEGER, INTENT( in ) ::   kn_fwb   ! ocean time-step index
+      !!
+      INTEGER  ::   inum = 11             ! temporary logical unit
+      INTEGER  ::   ikty, iyear           ! 
+      LOGICAL  ::   llbon
+      CHARACTER (len=32) ::   clname = 'EMPave_old.dat'
+      REAL(wp) ::   z_emp                 ! temporary scalars
+      !!----------------------------------------------------------------------
+      !
+      IF( kt == nit000 ) THEN
+         !
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'sbc_fwb : FreshWater Budget correction'
+            WRITE(numout,*) '~~~~~~~'
+            IF( kn_fwb == 1 )   WRITE(numout,*) '          instantaneously set to zero'
+            IF( kn_fwb == 2 )   WRITE(numout,*) '          adjusted from previous year budget'
+         ENDIF
+         !
+         e1e2_i(:,:) = e1t(:,:) * e2t(:,:) * tmask_i(:,:)
+         area = SUM( e1e2_i(:,:) )
+         IF( lk_mpp )   CALL  mpp_sum( area    )   ! sum over the global domain
+         !
+      ENDIF
+      
+
+      SELECT CASE ( kn_fwb )
+      !
+      CASE ( 1 )                               ! global mean emp set to zero
+         IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
+            z_emp = SUM( e1e2_i(:,:) * emp(:,:) ) / area
+            IF( lk_mpp )   CALL  mpp_sum( z_emp    )   ! sum over the global domain
+            emp (:,:) = emp (:,:) - z_emp
+            emps(:,:) = emps(:,:) - z_emp
+         ENDIF
+         !
+      CASE ( 2 )                               ! emp budget adjusted from the previous year
+         ! initialisation
+         IF( kt == nit000 ) THEN
+            ! Read the corrective factor on precipitations (empold)
+            INQUIRE( FILE=clname, EXIST=llbon )
+            IF( llbon ) THEN
+               OPEN ( inum, FILE=clname)
+               READ ( inum, "(24X,I8,2ES24.16)" ) iyear, a_fwb_b, a_fwb
+               CLOSE( inum )
+               empold = a_fwb                  ! current year freshwater budget correction
+               !                               ! estimate from the previous year budget
+               IF(lwp)WRITE(numout,*)
+               IF(lwp)WRITE(numout,*)'sbc_fwb : year = ',iyear  , ' freshwater budget correction = ', empold
+               IF(lwp)WRITE(numout,*)'          year = ',iyear-1, ' freshwater budget read       = ', a_fwb
+               IF(lwp)WRITE(numout,*)'          year = ',iyear-2, ' freshwater budget read       = ', a_fwb_b
+            ELSE
+               WRITE(ctmp1,*)'sbc_fwb : unable to read the file', clname
+               CALL ctl_stop( ctmp1 )
+            ENDIF
+         ENDIF
+         ! 
+         ! Update empold if new year start
+         ikty = 365 * 86400 / rdttra(1)    !!bug  use of 365 days leap year or 360d year !!!!!!!
+         IF( MOD( kt, ikty ) == 0 ) THEN
+            a_fwb_b = a_fwb
+            a_fwb   = SUM( e1e2_i(:,:) * sshn(:,:) )
+            IF( lk_mpp )   CALL  mpp_sum( a_fwb    )   ! sum over the global domain
+            a_fwb   = a_fwb * 1.e+3 / ( area * 86400. * 365. )     ! convert in Kg/m3/s = mm/s
+!!gm        !                                                      !!bug 365d year 
+            empold =  a_fwb                 ! current year freshwater budget correction
+            !                               ! estimate from the previous year budget
+         ENDIF
+         ! 
+         ! correct the freshwater fluxes
+         IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
+            emp (:,:) = emp (:,:) - empold
+            emps(:,:) = emps(:,:) - empold
+         ENDIF
+         !
+         ! save empold value in a file
+         IF( kt == nitend ) THEN
+            OPEN( inum, FILE='EMPave.dat' )
+            WRITE(inum, "(24X,I8,2ES24.16)" ) nyear, a_fwb_b, a_fwb
+         ENDIF
+         !
+      CASE DEFAULT    ! you should never be there
+         WRITE(ctmp1,*)'sbc_fwb : nn_fwb = ', kn_fwb, ' is not permitted for the FreshWater Budget correction, choose either 0/1/2'
+         CALL ctl_stop( ctmp1 )
+         !
+      END SELECT
+      !
+   END SUBROUTINE sbc_fwb
+
+   !!======================================================================
+END MODULE sbcfwb
Index: trunk/NEMO/OPA_SRC/SBC/sbcice_if.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 888)
+++ trunk/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 888)
@@ -0,0 +1,159 @@
+MODULE sbcice_if
+   !!======================================================================
+   !!                       ***  MODULE  sbcice  ***
+   !! Surface module :  update surface ocean boundary condition over ice
+   !!                   covered area using ice-if model
+   !!======================================================================
+   !! History :  9.0   !  06-06  (G. Madec)  Original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   sbc_ice_if     : update sbc in ice-covered area
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE phycst          ! physical constants
+   USE ocfzpt          ! ocean freezing point
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE fldread         ! read input field
+   USE iom             ! I/O manager library
+   USE in_out_manager  ! I/O manager
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   sbc_ice_if      ! routine called in sbcmod
+
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_ice   ! structure of input ice-cover (file informations, fields read)
+   
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE sbc_ice_if( kt )
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE sbc_ice_if  ***
+      !!
+      !! ** Purpose :   handle surface boundary condition over ice cover area
+      !!      when sea-ice model are not used
+      !!
+      !! ** Method  : - read sea-ice cover climatology
+      !!              - blah blah blah, ...
+      !!
+      !! ** Action  :   qns, qsr:  update heat flux below sea-ice
+      !!                emp, emps: update freshwater flux below sea-ice
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT(in)          ::   kt         ! ocean time step
+      !
+      CHARACTER(len=100) ::   cn_dir              ! Root directory for location of ice-if files
+      TYPE(FLD_N)        ::   sn_ice              ! informations about the fields to be read
+      NAMELIST/namsbc_iif/ cn_dir, sn_ice
+      !
+      INTEGER  ::   ji, jj     ! dummy loop indices
+      INTEGER  ::   ierror     ! return error code
+      REAL(wp) ::   ztrp, zsice, zt_fzp, zicover_obs, zicover_opa
+      REAL(wp) ::   zqri, zqrj, zqrp, zqi
+      !!---------------------------------------------------------------------
+      !                                         ! ====================== !
+      IF( kt == nit000 ) THEN                   !  First call kt=nit000  !
+         !                                      ! ====================== !
+         ! set file information
+         cn_dir = './'        ! directory in which the model is executed
+         ! ... default values (NB: frequency positive => hours, negative => months)
+         !            !   file    ! frequency !  variable  ! time intep !  clim  ! starting !
+         !            !   name    !  (hours)  !   name     !   (T/F)    !  (0/1) !  record  !
+         sn_ice = FLD_N('ice_cover',   -12.   ,  'ice_cov'  ,  .TRUE.    ,    1   ,     0    )
+
+         REWIND ( numnam )               ! ... read in namlist namiif
+         READ   ( numnam, namsbc_iif )
+
+         ALLOCATE( sf_ice(1), STAT=ierror )
+         IF( ierror > 0 ) THEN
+            CALL ctl_stop( 'sbc_ice_if: unable to allocate sf_ice structure' )   ;   RETURN
+         ENDIF
+
+         ! store namelist information in sf_ice structure
+         WRITE(sf_ice(1)%clrootname,'(a,a)' )   TRIM( cn_dir ), TRIM( sn_ice%clname )
+         sf_ice(1)%freqh   = sn_ice%freqh
+         sf_ice(1)%clvar   = sn_ice%clvar
+         sf_ice(1)%ln_tint = sn_ice%ln_tint
+         sf_ice(1)%nclim   = sn_ice%nclim
+         sf_ice(1)%nstrec  = sn_ice%nstrec
+
+         IF(lwp) THEN      ! control print
+            WRITE(numout,*)
+            WRITE(numout,*) 'sbc_ice_if : ice-if sea-ice model'
+            WRITE(numout,*) '~~~~~~~~~~ '
+            WRITE(numout,*) '   ice-cover data in the following file: '
+            WRITE(numout,*) '          list of files and frequency (>0: in hours ; <0 in months)'
+            WRITE(numout,*) '               root filename: '  , trim( sf_ice(1)%clrootname ),   &
+               &                          ' variable name: '  , trim( sf_ice(1)%clvar      )
+            WRITE(numout,*) '               frequency: '      ,       sf_ice(1)%freqh       ,   &
+               &                          ' time interp: '    ,       sf_ice(1)%ln_tint     ,   &
+               &                          ' climatology: '    ,       sf_ice(1)%nclim       ,   &
+               &                          ' starting record: ',       sf_ice(1)%nstrec
+         ENDIF
+         !
+      ENDIF
+
+      CALL fld_read( kt, nn_fsbc, sf_ice )           ! Read input fields and provides the
+      !                                              ! input fields at the current time-step
+      
+      IF( MOD( kt-1, nn_fsbc) == 0 ) THEN
+         !
+         ztrp = -40.             ! restoring terme for temperature (w/m2/k)
+         zsice = - 0.04 / 0.8    ! ratio of isohaline compressibility over isotherme compressibility
+                                 ! ( d rho / dt ) / ( d rho / ds )      ( s = 34, t = -1.8 )
+         ! Flux computation
+!CDIR COLLAPSE
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ! ... sea surface freezing point temperature [Celcius]
+               zt_fzp = (  ( - 0.0575 + 1.710523e-3 * SQRT( sss_m(ji,jj) )   &
+            &                         - 2.154996e-4 *       sss_m(ji,jj)   ) * sss_m(ji,jj)  ) * tmask(ji,jj,1)
+            
+               ! ... indicators : ice cover (obs, ocean model) & hemisphere (=1 north, =-1 south)
+               zicover_obs = sf_ice(1)%fnow(ji,jj)                                                ! observed 
+               zicover_opa = MAX( 0., SIGN( 1., zt_fzp - sst_m(ji,jj) )  ) * tmask(ji,jj,1)   ! model   
+
+               ! ... avoid over-freezing point temperature
+               tn(ji,jj,1) = MAX( tn(ji,jj,1), zt_fzp )
+
+               ! ... solar heat flux : zero below observed ice cover
+               qsr(ji,jj) = ( 1. - zicover_obs ) * qsr(ji,jj)
+
+               ! ... non solar heat flux : add a damping term 
+               !      - gamma*(t-(tgel-1.))  if observed ice and no opa ice   (zicover_obs=1 zicover_opa=0)
+               !      - gamma*min(0,t-tgel)  if observed ice and opa ice      (zicover_obs=1 zicover_opa=1)
+
+               zqri = ztrp * ( tb(ji,jj,1) - ( zt_fzp - 1.) )
+               zqrj = ztrp * MIN( 0., tb(ji,jj,1) - zt_fzp )
+
+               zqrp =  ( zicover_obs * ( (1. - zicover_opa ) * zqri    &
+                 &                      +      zicover_opa   * zqrj ) ) * tmask(ji,jj,1)
+
+               ! c) net downward heat flux q() = q0 + qrp()
+               ! for q0
+               ! # qns unchanged              if no climatological ice              (zicover_obs=0)
+               ! # qns = zqrp                 if climatological ice and no opa ice  (zicover_obs=1, zicover_opa=0)
+               ! # qns = zqrp -2(-4) watt/m2  if climatological ice and opa ice     (zicover_obs=1, zicover_opa=1)
+               ! (-2=arctic, -4=antarctic)   
+               zqi = -3. + SIGN( 1.e0, ff(ji,jj) )
+               qns(ji,jj) = ( ( 1.- zicover_obs ) * qns(ji,jj)   &
+                  &          +      zicover_obs   * zicover_opa * zqi ) * tmask(ji,jj,1)   &
+                  &       + zqrp
+            END DO
+         END DO
+         !
+      ENDIF
+      !
+   END SUBROUTINE sbc_ice_if
+
+   !!======================================================================
+END MODULE sbcice_if
